﻿

using System;
using System.Linq;
using System.Windows;
using Infragistics.Controls.Menus;

namespace TreeGlitch
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            var lContext = new ViewModel();
            DataContext = lContext;

            InitializeComponent();

            MyTree.UpdateLayout();

            return;
        }

        private void Button_Click( object sender, RoutedEventArgs e )
        {
            //Go down the tree, expand it.
            foreach ( var node in MyTree.Nodes )
            {
                ActivateNodeAndChildren( node );
            }

            //Go up the tree, collapsing
            Application.Current.Dispatcher.BeginInvoke( new Action( () =>
            {
                foreach ( var node in MyTree.Nodes.Reverse() )
                {
                    DeactivateNodeAndChildren( node );
                }
            } ) );
        }

        private void ActivateNodeAndChildren( XamDataTreeNode node )
        {
            node.IsActive = true;
            node.IsSelected = true;
            foreach ( var child in node.Nodes )
            {
                ActivateNodeAndChildren( child );
            }
        }

        private void DeactivateNodeAndChildren( XamDataTreeNode node )
        {
            node.IsActive = false;
            node.IsSelected = false;
            node.IsExpanded = false;
            foreach ( var child in node.Nodes )
            {
                DeactivateNodeAndChildren( child );
            }
        }
    }
}
