﻿

using System.Collections.ObjectModel;

namespace TreeGlitch
{
    public class ViewModel
    {
        public ViewModel()
        {
            Parents = new ObservableCollection<Parent>();

            var data1 = new Parent() { FirstName = "TestFirst" };
            data1.Children.Add( new Parent() { LastName = "TestLast" } );
            data1.Children[ 0 ].Cars.Add( new Cars() { Name = "TestCar" } );

            Parents.Add( data1 );

            var data2 = new Parent() { FirstName = "TestFirst2" };
            data2.Children.Add( new Parent() { LastName = "TestLast2" } );
            data2.Children[ 0 ].Cars.Add( new Cars() { Name = "TestCar2" } );

            Parents.Add( data2 );
        }

        public ObservableCollection<Parent> Parents
        {
            get;
            private set;
        }
    }

    public class Parent
    {
        ObservableCollection<Parent> _children;

        public string FirstName { get; set; }
        public string LastName { get; set; }

        public ObservableCollection<Parent> Children
        {
            get
            {
                if ( this._children == null )
                    this._children = new ObservableCollection<Parent>();

                return this._children;
            }
        }

        ObservableCollection<Cars> _cars;
        public ObservableCollection<Cars> Cars
        {
            get
            {
                if ( this._cars == null )
                {
                    this._cars = new ObservableCollection<Cars>();
                }
                return this._cars;
            }
        }
    }

    public class Cars
    {
        public string Name { get; set; }
    }
}
